; Non-Layered Dialog with Layered Controls  via SetLayeredWindowAttributes, v.2007-01-16, by kero <geocities.com/xmemor>

.386
.model flat,stdcall
option casemap:none

include windows.inc

inclib macro x
 include x.inc
 includelib x.lib
endm

inclib  user32
inclib  kernel32
inclib  gdi32
inclib  shell32
inclib	comctl32

.data
app							db " Non-Layered  Dialog  with  Layered  Controls  // SetLayeredWindowAttributes //  v.2007-01-16",0,"by kero <geocities.com/xmemor>",0
dlg							db "Dialog",0
ft							db "  %s    %s    ( WindowFromPoint )",0
_HTERROR        db "HTERROR",0            					; -2
_HTTRANSPARENT  db "HTTRANSPARENT",0      					; -1
_HTNOWHERE      db "HTNOWHERE",0          					;  0
_HTCLIENT       db "HTCLIENT",0           					;  1
_HTCAPTION      db "HTCAPTION",0          					;  2
_HTSYSMENU      db "HTSYSMENU",0										;  3
_HTGROWBOX      db "HTGROWBOX",0 ; = HTSIZE					;  4
_HTMENU         db "HTMENU",0												;  5
_HTHSCROLL      db "HTHSCROLL",0										;  6
_HTVSCROLL      db "HTVSCROLL",0										;  7
_HTMINBUTTON    db "HTMINBUTTON",0 ; = HTREDUCE			;  8
_HTMAXBUTTON    db "HTMAXBUTTON",0 ; = HTZOOM				;  9
_HTLEFT         db "HTLEFT",0 ; = HTSIZEFIRST				; 10
_HTRIGHT        db "HTRIGHT",0											; 11
_HTTOP          db "HTTOP",0												; 12
_HTTOPLEFT      db "HTTOPLEFT",0										; 13
_HTTOPRIGHT     db "HTTOPRIGHT",0										; 14
_HTBOTTOM       db "HTBOTTOM",0											; 15
_HTBOTTOMLEFT   db "HTBOTTOMLEFT",0									; 16
_HTBOTTOMRIGHT  db "HTBOTTOMRIGHT",0 ; = HTSIZELAST	; 17
_HTBORDER       db "HTBORDER",0											; 18
_HTOBJECT       db "HTOBJECT",0           					; 19
_HTCLOSE        db "HTCLOSE",0            					; 20
_HTHELP			    db "HTHELP",0             					; 21
tmid						dd 1
lwa							dd LWA_ALPHA
lwa_alpha				dd 128 ; 0
lwa_colorkey		dd 0
_static					db "static",0

.data?
hinst   				HINSTANCE ?
hw1							HWND ?
hw2							HWND ?
hbrush  				HBRUSH ?
hrgn						HRGN ?
flag						dd ?

.code

;###########################################################################

NewProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_WINDOWPOSCHANGING
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
		push eax
		invoke GetAncestor,hWnd,GA_PARENT
		invoke InvalidateRect,eax,0,1
		pop eax
		ret
	.elseif uMsg==WM_LBUTTONDOWN
		invoke GetKeyState,VK_CONTROL
		test eax,8000h
		jz @f
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam
	.else
@@:
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
NewProc endp

;###########################################################################

SubClass proc hWnd:HWND,param:DWORD

	invoke SetWindowLong,hWnd,GWL_WNDPROC,addr NewProc
	invoke SetWindowLong,hWnd,GWL_USERDATA,eax
	invoke LoadCursor,0,IDC_HAND
	invoke SetClassLong,hWnd,GCL_HCURSOR,eax
	xor eax,eax
	inc eax
	ret
SubClass endp

;###########################################################################

LWA_trigger proc uses ebx edi esi hWnd:HWND,param:DWORD
	local rt:RECT
	local pt:POINT

	invoke GetWindowRect,hWnd,addr rt
	invoke GetAncestor,hWnd,GA_PARENT
	mov ebx,eax
	invoke MapWindowPoints,0,ebx,addr rt,1
	invoke GetWindowLong,hWnd,GWL_EXSTYLE
	push eax
	and eax,WS_EX_LAYERED
	.if eax!=0
  	pop eax
		and eax,not WS_EX_LAYERED
		invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
	.else
		mov flag,eax
		mov pt.x,eax
		mov pt.y,eax
		invoke SetWindowLong,hWnd,GWL_ID,0
		mov edi,eax
		invoke MapWindowPoints,ebx,0,addr pt,1
		mov ecx,rt.left
		mov edx,rt.top
		mov eax,pt.x
		sub ecx,eax
		mov eax,pt.y
		sub edx,eax
		invoke SetWindowPos,hWnd,0,ecx,edx,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_HIDEWINDOW
		invoke SetParent,hWnd,0
		invoke GetClassLong,hWnd,GCL_STYLE
		mov esi,eax
		and eax,not CS_PARENTDC
		invoke SetClassLong,hWnd,GCL_STYLE,eax
  	pop eax
		or eax,WS_EX_LAYERED OR WS_EX_ACCEPTFILES
		invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
;		invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_HIDEWINDOW
		invoke SetLayeredWindowAttributes,hWnd,lwa_colorkey,lwa_alpha,lwa
		invoke SetParent,hWnd,ebx
		invoke SetWindowLong,hWnd,GWL_ID,edi
		invoke SetClassLong,hWnd,GCL_STYLE,esi
	.endif
	invoke SetWindowPos,hWnd,0,rt.left,rt.top,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_FRAMECHANGED
	invoke InvalidateRect,hWnd,0,1
	xor eax,eax
	inc eax
	ret
LWA_trigger endp

;###########################################################################

MakeFrame proc uses ebx edi hWnd:HWND,param:DWORD
	local rt:RECT
	local pt:POINT

	invoke GetWindowRect,hWnd,addr rt
	invoke GetAncestor,hWnd,GA_PARENT
	mov ebx,eax
	invoke MapWindowPoints,0,ebx,addr rt,2
	invoke GetDC,ebx
	mov edi,eax
	dec rt.left
	dec rt.top
	inc rt.right
	inc rt.bottom
	invoke GetStockObject,WHITE_BRUSH
	invoke FrameRect,edi,addr rt,eax
	xor eax,eax
	mov pt.x,eax
	mov pt.y,eax
	invoke MapWindowPoints,ebx,0,addr pt,1
	mov eax,pt.x
	sub rt.left,eax
	sub rt.right,eax
	mov eax,pt.y
	sub rt.top,eax
	sub rt.bottom,eax
	invoke GetStockObject,WHITE_BRUSH
	invoke FrameRect,edi,addr rt,eax
	invoke ReleaseDC,ebx,edi
	xor eax,eax
	inc eax
	ret
MakeFrame endp

;###########################################################################

ShowInit proc hWnd:HWND,param:DWORD

	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	xor eax,eax
	inc eax
	ret
ShowInit endp

;###########################################################################

PointInfo proc uses ebx edi hWnd:HWND
	local pt:POINT
	local rt:RECT
	local buf0[256]:BYTE
	local buf1[256]:BYTE
	local buf2[64]:BYTE

	invoke GetWindowText,hWnd,addr buf0,255
	invoke GetCursorPos,addr pt
	invoke GetWindowRect,hWnd,addr rt
	invoke PtInRect,addr rt,pt.x,pt.y
	.if eax==0
		mov ebx,offset app
	.else
		invoke WindowFromPoint,pt.x,pt.y
		mov ebx,eax
		mov eax,pt.y
		mov ecx,eax
		shl ecx,16
		mov edx,pt.x
		and edx,0ffffh
		add ecx,edx
		invoke DefWindowProc,ebx,WM_NCHITTEST,0,ecx
		mov ecx,eax
		mov eax,offset _HTERROR
		inc ecx
		inc ecx
		.while ecx!=0
@@:
			mov dl,byte ptr [eax]
			inc eax
			test dl,dl
			jnz @b
			dec ecx
		.endw
		mov edi,eax
		invoke GetClassName,ebx,addr buf2,255
		invoke wsprintf,addr buf1,offset ft,addr buf2,edi
		lea ebx,buf1
	.endif
	invoke lstrcmp,addr buf0,ebx
	.if eax!=0
		invoke SetWindowText,hWnd,ebx
	.endif
	ret
PointInfo endp

;###########################################################################

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local rt:RECT

	.if uMsg==WM_CLOSE
		invoke KillTimer,hWnd,tmid
		invoke DeleteObject,hbrush
		invoke DeleteObject,hrgn
		invoke EndDialog,hWnd,0

	.elseif uMsg==WM_INITDIALOG
		invoke SetWindowText,hWnd,offset app
		invoke EnumChildWindows,hWnd,addr SubClass,0
		invoke EnumChildWindows,hWnd,addr LWA_trigger,0
		invoke LoadImage,hinst,600,IMAGE_BITMAP,90,90,LR_DEFAULTCOLOR
		push eax
		invoke CreatePatternBrush,eax
		mov hbrush,eax
		call DeleteObject
		invoke FindWindowEx,hWnd,0,offset _static,0
		mov ebx,eax
		invoke GetWindowRect,ebx,addr rt
		mov edi,rt.right
		sub edi,rt.left
		mov esi,rt.bottom
		sub esi,rt.top
		invoke CreateRectRgn,0,0,edi,esi
		mov hrgn,eax
		mov eax,20
		sub edi,eax
		sub esi,eax
		invoke CreateRectRgn,eax,eax,edi,esi
		push eax
		invoke CombineRgn,hrgn,hrgn,eax,RGN_DIFF
		call DeleteObject
		invoke SetWindowRgn,ebx,hrgn,1
		invoke SetTimer,hWnd,tmid,100,0

	.elseif uMsg==WM_TIMER
		.if flag==0
			inc flag
			invoke EnumChildWindows,hWnd,addr ShowInit,0
		.endif
		invoke EnumChildWindows,hWnd,addr MakeFrame,0
		invoke PointInfo,hWnd

	.elseif uMsg==WM_RBUTTONUP
		invoke EnumChildWindows,hWnd,addr LWA_trigger,0

	.elseif uMsg==WM_LBUTTONDBLCLK
		invoke GetWindowLong,hWnd,GWL_STYLE
		mov ecx,eax
		mov edx,WS_CAPTION
		or eax,edx
		.if eax==ecx
			not edx
			and eax,edx
		.endif
		invoke SetWindowLong,hWnd,GWL_STYLE,eax
		invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED

	.elseif uMsg==WM_LBUTTONDOWN
		invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.elseif uMsg==WM_WINDOWPOSCHANGING
		invoke InvalidateRect,hWnd,0,1

	.elseif uMsg==WM_CTLCOLORDLG
		mov eax,hbrush
		ret

	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret
DlgProc endp

;###########################################################################

start:
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke DialogBoxParam,eax,offset dlg,0,offset DlgProc,0
	invoke ExitProcess,eax
	invoke InitCommonControls
end start

;###########################################################################
